# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: govuk_guix_revisions
#
#  commit_hash        :string           not null, primary key
#  store_path         :string
#  created_at         :datetime         not null
#  updated_at         :datetime         not null
#  archived           :boolean          default(FALSE), not null
#  available_services :json
#

class GovukGuix::Revision < ApplicationRecord
  self.primary_key = 'commit_hash'

  default_scope { order(:created_at).reverse_order }

  has_many :mini_environments, foreign_key: 'govuk_guix_revision_id'

  def all_available_services
    service_lists = available_services.map do |group|
      group['services']
    end

    service_lists.flatten
  end
end
