# GOV.UK Mini Environment Admin
# Copyright © 2018  Christopher Baines <mail@cbaines.net>
#
# This file is part of the GOV.UK Mini Environment Admin.
#
# The GOV.UK Mini Environment Admin is free software: you can
# redistribute it and/or modify it under the terms of the GNU Affero
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later
# version.
#
# The GOV.UK Mini Environment Admin is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with the GOV.UK Mini Environment Admin.  If not, see
# <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: mini_environment_services
#
#  id                  :integer          not null, primary key
#  name                :string
#  revision            :string
#  mini_environment_id :integer
#  created_at          :datetime         not null
#  updated_at          :datetime         not null
#

class MiniEnvironmentService < ApplicationRecord
  belongs_to :mini_environment

  def customised?
    service = mini_environment
                .govuk_guix_revision
                .all_available_services
                .find do |s|

      s['name'] == name
    end

    service['package']['version'] != revision
  end

  def build_argument_string
    if customised?
      "#{name}@#{revision}"
    else
      name
    end
  end
end
